## happy 1.20.1.1

=== Makefile ===
CABAL = cabal

HAPPY = happy
HAPPY_OPTS = -agc
HAPPY_VER = `awk '/^version:/ { print $$2 }' happy.cabal`

ALEX = alex
ALEX_OPTS = -g

SDIST_DIR=dist-newstyle/sdist
TARBALL="${SDIST_DIR}/happy-$(HAPPY_VER).tar.gz"

GEN = src/gen/Parser.hs src/gen/AttrGrammarParser.hs

all : $(GEN)

src/gen/%.hs : src/boot/%.ly
	$(HAPPY) $(HAPPYFLAGS) $< -o $@

sdist ::
	@case "`$(CABAL) --numeric-version`" in \
		2.[2-9].* | [3-9].* ) ;; \
		* ) echo "Error: needs cabal 2.2.0.0 or later (but got : `$(CABAL) --numeric-version`)" ; exit 1 ;; \
	esac
	@if [ "`git status -s`" != '' ]; then \
		echo Tree is not clean; \
		exit 1; \
	fi
	$(HAPPY) $(HAPPY_OPTS) src/Parser.ly -o src/Parser.hs
	$(HAPPY) $(HAPPY_OPTS) src/AttrGrammarParser.ly -o src/AttrGrammarParser.hs
	mv src/Parser.ly src/Parser.ly.boot
	mv src/AttrGrammarParser.ly src/AttrGrammarParser.ly.boot
	$(CABAL) v2-run gen-happy-sdist
	cabal v2-sdist
	@if [ ! -f "${TARBALL}" ]; then \
		echo "Error: source tarball not found: ${TARBALL}"; \
		exit 1; \
	fi
	git checkout .
	git clean -f

sdist-test :: sdist sdist-test-only
	@rm -rf "${SDIST_DIR}/happy-${HAPPY_VER}/"

sdist-test-only ::
	@if [ ! -f "${TARBALL}" ]; then \
		echo "Error: source tarball not found: ${TARBALL}"; \
		exit 1; \
	fi
	rm -rf "${SDIST_DIR}/happy-$(HAPPY_VER)/"
	tar -xf "${TARBALL}" -C ${SDIST_DIR}/
	echo "packages: ." > "${SDIST_DIR}/happy-$(HAPPY_VER)/cabal.project"
	cd "${SDIST_DIR}/happy-$(HAPPY_VER)/" && cabal v2-test --enable-tests all
	@echo ""
	@echo "Success! ${TARBALL} is ready for distribution!"
	@echo ""

# Export name of generated tarball for e.g. use in CI.
print-tarball:
	@echo ${TARBALL}

=== examples/glr/bio-eg/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

PROG=bio-eg

# filtering causes this example to fail...
FILTER = --filter
FILTER =

.hi.o :
	@ dummy

${PROG} : Bio.o Main.lhs
	${GHC} -cpp -fglasgow-exts  -o ${PROG} --make Main.lhs

BioData.hs Bio.hs : Bio.y
	${HAPPY} --info --glr --ghc ${FILTER} $<

Bio.o : Bio.hs BioData.hi
	${GHC} -cpp -fglasgow-exts  -O2 -c Bio.hs

DATA_FLAGS = -funfolding-use-threshold0 -fno-strictness
BioData.hi BioData.o : BioData.hs
	@echo "Making BioData.hs WITHOUT optimisation (for speed)"
	${GHC} -cpp -fglasgow-exts  ${DATA_FLAGS} -c $<

run : run12

run6 : ${PROG}
	./${PROG} +RTS -s -K5M -RTS `cat 1-600.dna`

run12 : ${PROG}
	rm -f out.1200
	./${PROG} +RTS -s -K15M -RTS `cat 1-1200.dna` > out.1200 2>&1
	echo Expect NINE matches, got `grep '^[(,0-9]*G_Match' out.1200 | wc -l`

clean :
	rm -rf ${PROG} Bio.info Bio.hs BioData.hs *.o *.hi out.daVinci \
		out.1200 out.600

=== examples/glr/expr-monad/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

DECODE = --decode


expr : Expr.hs Main.lhs
	${GHC} -cpp -fglasgow-exts  -o expr --make Main.lhs

run : expr
	./expr "1+2*4-3"

eof : expr
	echo testing premature eof
	./expr "1+2*"

err : expr
	echo testing syntax error
	./expr "1+2*2++3"

test : run eof err

clean :
	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci

=== examples/glr/packing/Makefile ===
TOP = ..
include $(TOP)/Makefile.defs

FILTER = --filter
FILTER =

.y.hs :
	${HAPPY} -i -l $*.y ${FILTER}

expr : Expr.hs Main.lhs
	${GHC} -cpp -fglasgow-exts  -o expr --make Main.lhs

run : expr
	./expr "+ 1 1 1 1 1 1 "

eof : expr
	echo testing premature eof
	./expr ""

err : expr
	echo testing syntax error
	./expr "+ 1 +"

test : run eof err

clean :
	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci

=== debian/changelog ===
happy (1.20.1.1-1) unstable; urgency=medium

  * New upstream release
  * Declare compliance with Debian policy 4.6.2

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 27 Aug 2023 13:36:19 +0300

=== debian/control ===
Source: happy
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@ubuntu.com>
Priority: optional
Section: haskell
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 cdbs (>= 0.4.59),
 haskell-devscripts (>= 0.13),
 debhelper (>= 10),
 dpkg-dev (>= 1.17.14),
 autoconf,
 docbook-utils,
 ghc (>= 9.4),
 ghc-prof,
 docbook-xsl,
 docbook-xml,
 xsltproc,
 happy <!stage1>,
Homepage: https://www.haskell.org/happy/
Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/happy]
Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/happy

Package: happy
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${haskell:Depends},
Recommends: ${haskell:Recommends},
Suggests: haskell-doc,
 info-browser,
 ${haskell:Suggests},
Replaces: ghc-cvs (<< 20031221),
Description: Parser generator for Haskell
 Happy is a parser generator system for Haskell, similar to the tool `yacc' for
 C. Like `yacc', it takes a file containing an annotated BNF specification of a
 grammar and produces a Haskell module containing a parser for the grammar.
 .
 Happy is flexible: you can have several Happy parsers in the same program, and
 several entry points to a single grammar. Happy can work in conjunction with a
 lexical analyser supplied by the user (either hand-written or generated by
 another program), or it can parse a stream of characters directly (but this
 isn't practical in most cases).

=== debian/rules ===
#! /usr/bin/make -f
# Made with the aid of dh_make, by Craig Small
# debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.
# Largely rewritten for the Cabalised happy by Ian Lynagh in 2006.
# Largely rewritten for cdbs and hlibrary.mk by Iain Lane in 2009.

DEB_BUILD_DEPENDENCIES = build-arch

DEB_SETUP_GHC_CONFIGURE_ARGS := --datasubdir=/usr/share/happy --docdir=/usr/share/doc/happy

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk
include /usr/share/cdbs/1/rules/utils.mk

ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
DEB_SETUP_GHC_CONFIGURE_ARGS += --with-happy=/bin/true
endif

clean::
	[ ! -f doc/config.mk ] || $(MAKE) -C doc clean

	rm -f debian/get_version.o debian/get_version.hi debian/get_version
	rm -f doc/happy.1

	# Hacks:
	rm -f doc/config.log doc/config.status doc/config.mk doc/configure

configure/happy::
	# doc/configure is not shipped, generate it
	cd doc && autoconf && rm -r autom4te.cache &&  ./configure --prefix=/usr
	# used in build to stick version into man page
	ghc --make debian/get_version.hs -o debian/get_version

build/happy:: build-ghc-stamp
	$(MAKE) -C doc html
	sed -e "s#@LIBDIR@#/usr/share/happy-`debian/get_version`#g" \
	    -e "s#@DOCDIR@#/usr/share/doc/happy#g" \
	    -e "s#@VERSION@#`debian/get_version`#g" \
	  doc/happy.1.in > doc/happy.1

# install templates to appropriate directory
binary-post-install/happy::
	$(DEB_SETUP_BIN_NAME) copy --builddir=dist-ghc --destdir=debian/happy
	rm -f debian/happy/usr/share/doc/happy/LICENSE

=== debian/watch ===
version=3
https://hackage.haskell.org/package/happy/distro-monitor .*-([0-9\.]+).(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## happy 2.1.7

=== debian/changelog ===
happy (2.1.7-2) unstable; urgency=medium

  * Add runtime depends on haskell-happy-lib-data (Closes: #1126852)

 -- Scott Talbert <swt@techie.net>  Tue, 03 Feb 2026 18:08:47 -0500

happy (2.1.7-1) unstable; urgency=medium

  [ Clint Adams ]
  * New upstream version.

  [ Scott Talbert ]
  * Fix a few dh-haskell porting issues and depend on happy-lib >= 2.1.7-3

 -- Scott Talbert <swt@techie.net>  Fri, 30 Jan 2026 21:10:02 -0500

happy (1.20.1.1-2) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Declare compliance with Debian policy 4.7.0

  [ Scott Talbert ]
  * Build using dh-haskell
  * Remove unused utils.mk include from d/rules (Closes: #1110564)

 -- Scott Talbert <swt@techie.net>  Wed, 17 Dec 2025 19:05:55 -0500

=== debian/control ===
--- 
+++ 
@@ -3,20 +3,17 @@
 Uploaders: Iain Lane <laney@ubuntu.com>
 Priority: optional
 Section: haskell
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Build-Depends:
- cdbs (>= 0.4.59),
- haskell-devscripts (>= 0.13),
- debhelper (>= 10),
+ dh-sequence-haskell,
+ haskell-devscripts (>= 0.16.45),
+ debhelper-compat (= 13),
  dpkg-dev (>= 1.17.14),
- autoconf,
- docbook-utils,
  ghc (>= 9.4),
  ghc-prof,
- docbook-xsl,
- docbook-xml,
- xsltproc,
+ libghc-happy-lib-dev (>= 2.1.7-3),
+ libghc-happy-lib-dev (<< 2.1.8),
  happy <!stage1>,
 Homepage: https://www.haskell.org/happy/
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/happy]
@@ -27,6 +24,8 @@
 Depends: ${shlibs:Depends},
  ${misc:Depends},
  ${haskell:Depends},
+ haskell-happy-lib-data (>= 2.1.7-3),
+ haskell-happy-lib-data (<< 2.1.8),
 Recommends: ${haskell:Recommends},
 Suggests: haskell-doc,
  info-browser,

=== debian/rules ===
#! /usr/bin/make -f
# Made with the aid of dh_make, by Craig Small
# debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.
# Largely rewritten for the Cabalised happy by Ian Lynagh in 2006.
# Largely rewritten for cdbs and hlibrary.mk by Iain Lane in 2009.

export DEB_SETUP_GHC_CONFIGURE_ARGS := --datasubdir=/usr/share/happy --docdir=/usr/share/doc/happy

ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
export DEB_SETUP_GHC_CONFIGURE_ARGS += --with-happy=/bin/true
endif

%:
	dh $@

## happy repo-0.1.4

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python -msphinx
SPHINXPROJ    = happy_repo
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
